> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Set User eMode

> Set the user's efficiency mode (eMode) category on Aave.

Efficiency mode (eMode) allows borrowers to extract the highest borrowing power when
collateral and borrowed assets are correlated in price, particularly for stablecoin
pairs. Each eMode category has specific LTV and liquidation threshold settings.
Setting category_id to 0 disables eMode, while other values enable specific eMode
categories defined by the protocol.



## OpenAPI

````yaml /v1/combined_spec.json post /v1/aave/set_user_emode
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/aave/set_user_emode:
    post:
      tags:
        - Aave V3
      summary: Set User eMode
      description: >-
        Set the user's efficiency mode (eMode) category on Aave.


        Efficiency mode (eMode) allows borrowers to extract the highest
        borrowing power when

        collateral and borrowed assets are correlated in price, particularly for
        stablecoin

        pairs. Each eMode category has specific LTV and liquidation threshold
        settings.

        Setting category_id to 0 disables eMode, while other values enable
        specific eMode

        categories defined by the protocol.
      operationId: v1_aave_set_user_emode
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AaveSetUserEModeRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.aave_v3.aave_set_user_emode(category_id=2, chain=models.AaveSetUserEModeRequestChain.BASE, sender="0xBa5e0D5cB0e661Bd6E68d8D667ceCb87aa0F95C1", estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.aaveV3.aaveSetUserEmode({
                categoryId: 2,
                chain: "base",
                sender: "0xBa5e0D5cB0e661Bd6E68d8D667ceCb87aa0F95C1",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    AaveSetUserEModeRequest:
      properties:
        action_type:
          type: string
          const: AAVE_SET_USER_EMODE
          title: Action Type
          default: AAVE_SET_USER_EMODE
        category_id:
          type: integer
          maximum: 255
          minimum: 0
          title: Category Id
          description: >-
            The eMode category ID to set for the user. 0 = no eMode, 1+ =
            specific eMode category.
          examples:
            - 0
            - 1
            - 2
          default: 2
        chain:
          type: string
          enum:
            - arbitrum
            - base
            - ethereum
          title: Chain
          default: base
          examples:
            - base
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0xBa5e0D5cB0e661Bd6E68d8D667ceCb87aa0F95C1'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - category_id
        - chain
        - sender
      title: AaveSetUserEModeRequest
      default:
        chain: base
        sender: '0xBa5e0D5cB0e661Bd6E68d8D667ceCb87aa0F95C1'
        category_id: 2
      required_allowances: []
    TransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
      type: object
      required:
        - transaction
      title: TransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````